package tp3;
import tp3.Rank;
import tp3.Color;
import java.util.Arrays;

public class Card {
    private Color color;
    private Rank rank;

    public Color getColor() {
        return color;
    }

    public Rank getRank() {
        return rank;
    }

    public String toString() {
        return this.color+" "+this.rank;
    }

    public Card(Color color, Rank rank){
        this.rank=rank;
        this.color=color;
    }

    public Card(String color, String rank){
        this.rank=Rank.valueOf(rank);
        this.color=Color.valueOf(color);
    }

    
    public boolean equals(Card carte){
        if (this.rank==carte.rank && this.color==carte.color){
            return true;
        }
        return false;
    }

    public boolean isBefore(Card carte){
        if (this.rank.ordinal()<carte.rank.ordinal()){
            return true;
        }
        return false;
    }

    public int compareRank(Card carte){
        if (this.rank.ordinal()<carte.rank.ordinal()){
            return -1;
        }else if (this.rank.ordinal()==carte.rank.ordinal()){
            return 0;
        }
        return 1;
    }

    public int compareColor(Card carte){
        if (this.color.ordinal()<carte.color.ordinal()){
            return -1;
        }else if (this.color.ordinal()==carte.color.ordinal()){
            return 0;
        }
        return 1;
    }

}
