package tp4;

public class Person{
    private static int ID = -1; //pour être à 0 sur la première assignation 
    private String forename;
    private String name;

    public Person(String forename, String name){
        this.forename = forename;
        this.name = name;
        ID++; //assignation automatique
    }


//getters

    int getID() { 
        return this.ID;
    }

    String getForename(){
        return this.forename;
    }

    String getName(){
        return this.name;
    }


//setters
    void setName(String name){
        this.name = name;
    }

    void setForename(String forename){
        this.forename = forename;
    }

    public String toString(){
        return getID()+":"+getForename()+" "+getName();
    }

    

    public boolean equals(Object obj) {
        if(this == obj) return true;
        if(obj == null) return false;
        if(getClass() != obj.getClass()) return false;
        Person other = (Person) obj;
        if(ID != other.ID) return false;
        if (name == null) {
            if (other.name != null) return false;
        } else if (!name.equals(other.name)) return false;
        if (forename == null) {
            if (other.forename != null) return false;
        } else if (!forename.equals(other.forename)) return false;
        return true;
    }
}